## tesseract 4.00~git2174-3b62badd

=== debian/changelog ===
tesseract (4.00~git2174-3b62badd-5) unstable; urgency=medium

  * Promote to unstable. Hope it goes well.

 -- Jeff Breidenbach <jab@debian.org>  Mon, 18 Dec 2017 16:49:22 -0800

tesseract (4.00~git2174-3b62badd-4) experimental; urgency=medium

  * Remove tesseract-ocr-dev transition package, no longer needed.

 -- Jeff Breidenbach <jab@debian.org>  Sat, 16 Dec 2017 14:50:00 -0800

tesseract (4.00~git2174-3b62badd-3) experimental; urgency=medium

  * Tighten up dependencies. (closes: #836849)

 -- Jeff Breidenbach <jab@debian.org>  Mon, 11 Dec 2017 14:45:22 -0800

tesseract (4.00~git2174-3b62badd-2) experimental; urgency=medium

  * Migrate to experimental; no source changes.

 -- Jeff Breidenbach <jab@debian.org>  Mon, 18 Sep 2017 15:01:09 -0700

tesseract (4.00~git2174-3b62badd-1ppa1~zesty1) zesty; urgency=medium

  * Automated backport upload; no source changes.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Sun, 17 Sep 2017 22:12:42 +0300

tesseract (4.00~git2174-3b62badd-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/tesseract-ocr/tesseract.git
  * Branch: master
  * Commit: 3b62badd770641aa8354696eed604e8606ad74eb
  * Date: 1505655538
  * git changelog:
  *  3b62badd - Merge pull request #1134 from
    Shreeshrii/fixvalidcodepoint
  *  a404c9cd - change type to UChar32 to fix IsValidCodepoint

 -- Alexander Pozdnyakov <almipo@mail.ru>  Sun, 17 Sep 2017 22:12:35 +0300

tesseract (4.00~git2172-e62e8f5f-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/tesseract-ocr/tesseract.git
  * Branch: master
  * Commit: e62e8f5f802c0d8f3dd67da993327cdafaee9763
  * Date: 1505457921
  * git changelog:
  *  e62e8f5f - Merge pull request #1109 from mingodad/mingodad-fix-
    interword-spaces
  *  188e1fc2 - Merge pull request #1128 from vidiecan/issue_1127
  *  2a77d5ad - returns the correct dictionary if lstm only used
  *  d962d344 - Merge pull request #1126 from stweil/unittest
  *  67f706f9 - unittest/apiexample_test: Use googletest API for error
    handling
  *  b42df389 - unittest/apiexample_test: Report missing test image
  *  5c7600c2 - unittest/apiexample_test: Fix test for out-of-tree
    builds
  *  86555247 - unittest/apiexample_test: Use "C" locale
  *  7e4f5faa - Merge pull request #1123 from stweil/googletest
  *  4ae227df - unittest: Fix path for libtesseract in out of tree
    builds
  *  04b0397c - Merge pull request #1120 from amitdo/multiplelibs
  *  876344f8 - Merge pull request #1121 from Shreeshrii/install-git-
    instructions
  *  c55e487e - Add additional information
  *  a905548e - Autotools build: Remove the option 'USING_MULTIPLELIBS'
  *  dd422c36 - Merge pull request #1118 from Shreeshrii/fixoverwrite
  *  4e9c9758 - fix accidental overwrite using old version
  *  7569c899 - Merge pull request #1116 from Shreeshrii/fixunittest
  *  9a038f89 - Add merge_unicharsets to build
  *  f6c22dbf - remove duplicate - gunit.h
  *  c50e4f62 - Fix cppan dependency.
  *  36e0d209 - Fix windows build.
  *  63e18620 - Disable travis os x builds as they do not work well on
    travis-side.
  *  3493785f - Fixed apiexample and intsimdmatrix tests and prepared
    Makefile.am for more tests
  *  9d258e20 - Fixed build of unicharset_extractor
  *  fc6a390c - Added intsimdmatrix as a generic integer matrixdotvector
    function with AVX2 and SSE specializations
  *  ad74e8a6 - Fixed integer overflow error
  *  4cf123e0 - Added ability to randomly rotate images upside-down
    during training for training OSD
  *  3e63918f - Fixed order of characters in ligatures of RTL languages
    issue #648
  *  a912967c - Rewrote unicharset_extractor to use the new string
    normalizer and read plain text as well as box files.
  *  c773eb57 - Fixed rendering of Thai and units of char spacing
  *  e96d1df0 - Fixed leaks in pango font info
  *  bf774382 - Updated comments on RemapOutputs
  *  0382222d - More clang-tidy fixes from sync
  *  f25cc27a - Update fopr leptonica 1.74
  *  a2a72d7c - Clang tidy changes from sync
  *  a18620cf - Improved results on images with no resolution. Estimates
    resolution from the size of the connected components, based on
    average text size.
  *  147a1a50 - Merge pull request #1112 from Sineaggi/fix-unix-simd
  *  0d7c89ea - Add -mavx and -msse4.1 compile flags on unix
  *  ea557a3e - Fix to preserve_interword_spaces work again
  *  f29498ff - Merge pull request #1088 from Shreeshrii/master
  *  3104c426 - Merge pull request #1104 from stweil/typo
  *  69ef9401 - Groundtruth for testing/eurotext.tif
  *  e0464a0d - Delete readme.md
  *  f7284569 - Use groundtruth from testing directory
  *  0ed7317c - Rename unittest/testfiles/phototest.txt to
    testing/phototest.txt
  *  61f96981 - training: Fix typos in comments (found by codespell)
  *  b9365cdf - api: Fix typo in comment
  *  10cf5084 - Changed syntax for AM_CPPFLAGS
  *  3b05b3e2 - revert blank line at end
  *  6ac5d0ba - dawg: Fix typos and file information in file header
  *  9c2fa0d1 - Merge pull request #1100 from Sineaggi/master
  *  69b9d298 - Fix version.h not being installed
  *  52cac3a4 - Fix library being named liblibtesseract on non win32
    platforms

 -- Alexander Pozdnyakov <almipo@mail.ru>  Sat, 16 Sep 2017 00:24:43 +0300

tesseract (4.00~git2113-27d25e9c-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/tesseract-ocr/tesseract.git
  * Branch: master
  * Commit: 27d25e9c99ca65a2137f54f4c9c2bd20fc050024
  * Date: 1503555413
  * git changelog:
  *  27d25e9c - Merge pull request #1094 from stweil/spaces
  *  b016c48d - Add missing spaces in help text
  *  1e3bf29c - Merge pull request #1092 from stweil/fixtext
  *  8bb5a89d - Don't add empty line to text output
  *  de98a68d - Merge pull request #1089 from stweil/text
  *  742b3035 - Fix hint for training build
  *  6f13d755 - Merge pull request #1051 from stweil/googletest
  *  3847b7dd - Merge pull request #1085 from KindDragon/patch-1


=== debian/control ===
Source: tesseract
Section: graphics
Priority: optional
Maintainer: Jeff Breidenbach <jab@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libleptonica-dev (>= 1.72~), 
               automake, libtool, libpango1.0-dev, libcairo2-dev, libicu-dev, 
               libpng-dev, libjpeg-dev, libtiff-dev, zlib1g-dev, git, autoconf-archive, asciidoc, 
               xsltproc, docbook-xsl, docbook-xml
Standards-Version: 3.9.8
Homepage: https://github.com/tesseract-ocr/

Package: libtesseract-dev
Section: libdevel
Architecture: any
Depends: libtesseract4 (= ${binary:Version}), ${misc:Depends}, libleptonica-dev
Replaces: tesseract-ocr-dev (<< 3.0.1-1~)
Breaks: tesseract-ocr-dev (<< 3.0.1-1~)
Description: Development files for the tesseract command line OCR tool
 The Tesseract OCR engine was one of the top 3 engines in the 1995
 UNLV Accuracy test. Between 1995 and 2006 it had little work done on
 it, but since then it has been improved extensively by Google and is
 probably one of the most accurate open source OCR engines
 available. It can read a wide variety of image formats and convert
 them to text in over 40 languages. This package includes the development
 files, static library, and header files.

Package: libtesseract4
Breaks: tesseract-ocr (<< 3.01~), ocropus (<< 0.4.0~),
 tesseract-afr (<< 4.00~), tesseract-ara (<< 4.00~), tesseract-aze (<< 4.00~),
 tesseract-bel (<< 4.00~), tesseract-ben (<< 4.00~), tesseract-bul (<< 4.00~),
 tesseract-cat (<< 4.00~), tesseract-ces (<< 4.00~), tesseract-chi-sim (<< 4.00~),
 tesseract-chi-tra (<< 4.00~), tesseract-chr (<< 4.00~), tesseract-dan (<< 4.00~),
 tesseract-deu (<< 4.00~), tesseract-deu-frak (<< 4.00~), tesseract-ell (<< 4.00~),
 tesseract-eng (<< 4.00~), tesseract-enm (<< 4.00~), tesseract-epo (<< 4.00~),
 tesseract-equ (<< 4.00~), tesseract-est (<< 4.00~), tesseract-eus (<< 4.00~),
 tesseract-fin (<< 4.00~), tesseract-fra (<< 4.00~), tesseract-frk (<< 4.00~),
 tesseract-frm (<< 4.00~), tesseract-glg (<< 4.00~), tesseract-grc (<< 4.00~),
 tesseract-heb (<< 4.00~), tesseract-hin (<< 4.00~), tesseract-hrv (<< 4.00~),
 tesseract-hun (<< 4.00~), tesseract-ind (<< 4.00~), tesseract-isl (<< 4.00~),
 tesseract-ita (<< 4.00~), tesseract-ita-old (<< 4.00~), tesseract-jpn (<< 4.00~),
 tesseract-kan (<< 4.00~), tesseract-kor (<< 4.00~),  tesseract-lav (<< 4.00~),
 tesseract-lit (<< 4.00~), tesseract-mal (<< 4.00~), tesseract-mkd (<< 4.00~),
 tesseract-mlt (<< 4.00~), tesseract-msa (<< 4.00~), tesseract-nld (<< 4.00~),
 tesseract-nor (<< 4.00~), tesseract-ocr-amh (<< 4.00~), tesseract-ocr-asm (<< 4.00~),
 tesseract-ocr-aze-cyrl (<< 4.00~), tesseract-ocr-bod (<< 4.00~), tesseract-ocr-bos (<< 4.00~),
 tesseract-ocr-ceb (<< 4.00~), tesseract-ocr-cym (<< 4.00~), tesseract-ocr-dan-frak (<< 4.00~),
 tesseract-ocr-dzo (<< 4.00~), tesseract-ocr-fas (<< 4.00~), tesseract-ocr-gle (<< 4.00~),
 tesseract-ocr-gle-uncial (<< 4.00~), tesseract-ocr-grc (<< 4.00~), tesseract-ocr-guj (<< 4.00~),
 tesseract-ocr-hat (<< 4.00~), tesseract-ocr-iku (<< 4.00~), tesseract-ocr-jav (<< 4.00~),
 tesseract-ocr-kat (<< 4.00~), tesseract-ocr-kat-old (<< 4.00~), tesseract-ocr-kaz (<< 4.00~),
 tesseract-ocr-khm (<< 4.00~), tesseract-ocr-kir (<< 4.00~), tesseract-ocr-kur (<< 4.00~),
 tesseract-ocr-lao (<< 4.00~), tesseract-ocr-lat (<< 4.00~), tesseract-ocr-mar (<< 4.00~),
 tesseract-ocr-mya (<< 4.00~), tesseract-ocr-nep (<< 4.00~), tesseract-ocr-ori (<< 4.00~),
 tesseract-ocr-pan (<< 4.00~), tesseract-ocr-pus (<< 4.00~), tesseract-ocr-san (<< 4.00~),
 tesseract-ocr-sin (<< 4.00~), tesseract-ocr-srp-latn (<< 4.00~), tesseract-ocr-syr (<< 4.00~),
 tesseract-ocr-tgk (<< 4.00~), tesseract-ocr-tir (<< 4.00~), tesseract-ocr-uig (<< 4.00~),
 tesseract-ocr-urd (<< 4.00~), tesseract-ocr-uzb (<< 4.00~), tesseract-ocr-uzb-cyrl (<< 4.00~),
 tesseract-ocr-yid (<< 4.00~), tesseract-pol (<< 4.00~), tesseract-por (<< 4.00~),
 tesseract-ron (<< 4.00~), tesseract-rus (<< 4.00~), tesseract-slk (<< 4.00~),
 tesseract-slk-frak (<< 4.00~), tesseract-slv (<< 4.00~), tesseract-spa (<< 4.00~),
 tesseract-spa-old (<< 4.00~), tesseract-sqi (<< 4.00~), tesseract-srp (<< 4.00~),
 tesseract-swa (<< 4.00~), tesseract-swe (<< 4.00~), tesseract-tam (<< 4.00~),
 tesseract-tel (<< 4.00~), tesseract-tgl (<< 4.00~), tesseract-tha (<< 4.00~),
 tesseract-tur (<< 4.00~), tesseract-ukr (<< 4.00~), tesseract-vie (<< 4.00~)
Replaces: tesseract-ocr (<< 3.01~)
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tesseract OCR library
 The Tesseract OCR engine was one of the top 3 engines in the 1995
 UNLV Accuracy test. Between 1995 and 2006 it had little work done on
 it, but since then it has been improved extensively by Google and is
 probably one of the most accurate open source OCR engines
 available. It can read a wide variety of image formats and convert
 them to text in over 40 languages. This package includes the shared
 library.

Package: tesseract-ocr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 tesseract-ocr-eng (>= 4.00~), tesseract-ocr-osd (>= 4.00~), libtesseract4 (>= 4.00~)
Replaces: tesseract-ocr-data
Description:tesseract command line OCR tool
 The Tesseract OCR engine was one of the top 3 engines in the 1995
 UNLV Accuracy test. Between 1995 and 2006 it had little work done on
 it, but since then it has been improved extensively by Google and is
 probably one of the most accurate open source OCR engines
 available. It can read a wide variety of image formats and convert
 them to text in over 40 languages. This package includes the command
 line tool.

Package: tesseract-ocr-all
Architecture: all
Depends: ${misc:Depends}, tesseract-ocr, 
        tesseract-ocr-bul, tesseract-ocr-cat, tesseract-ocr-ces, tesseract-ocr-dan, 
        tesseract-ocr-deu, tesseract-ocr-ell, tesseract-ocr-eng, tesseract-ocr-fin, 
        tesseract-ocr-fra, tesseract-ocr-hun, tesseract-ocr-ind, tesseract-ocr-ita, 
        tesseract-ocr-lav, tesseract-ocr-lit, tesseract-ocr-nld, tesseract-ocr-nor, 
        tesseract-ocr-pol, tesseract-ocr-por, tesseract-ocr-ron, tesseract-ocr-rus, 
        tesseract-ocr-slk, tesseract-ocr-slv, tesseract-ocr-spa, tesseract-ocr-srp, 
        tesseract-ocr-swe, tesseract-ocr-tur, tesseract-ocr-ukr, tesseract-ocr-vie, 
        tesseract-ocr-chi-sim, tesseract-ocr-chi-tra, tesseract-ocr-amh, tesseract-ocr-asm, 
        tesseract-ocr-aze-cyrl, tesseract-ocr-bod, tesseract-ocr-bos, tesseract-ocr-ceb, 
        tesseract-ocr-cym, tesseract-ocr-dzo, tesseract-ocr-fas, tesseract-ocr-gle, 
        tesseract-ocr-guj, tesseract-ocr-hat, tesseract-ocr-iku, tesseract-ocr-jav, 
        tesseract-ocr-kat, tesseract-ocr-kat-old, tesseract-ocr-kaz, tesseract-ocr-khm, 
        tesseract-ocr-kir, tesseract-ocr-lao, tesseract-ocr-lat, tesseract-ocr-mar, 
        tesseract-ocr-mya, tesseract-ocr-nep, tesseract-ocr-ori, tesseract-ocr-pan, 
        tesseract-ocr-pus, tesseract-ocr-san, tesseract-ocr-sin, tesseract-ocr-srp-latn, 
        tesseract-ocr-syr, tesseract-ocr-tgk, tesseract-ocr-tir, tesseract-ocr-uig, 
        tesseract-ocr-urd, tesseract-ocr-uzb, tesseract-ocr-uzb-cyrl, tesseract-ocr-yid, 
        tesseract-ocr-osd, tesseract-ocr-afr, tesseract-ocr-ara, tesseract-ocr-aze, 
        tesseract-ocr-bel, tesseract-ocr-ben, tesseract-ocr-chr, tesseract-ocr-enm, 
        tesseract-ocr-epo, tesseract-ocr-est, tesseract-ocr-eus, tesseract-ocr-frk, 
        tesseract-ocr-frm, tesseract-ocr-glg, tesseract-ocr-heb, tesseract-ocr-hin, 
        tesseract-ocr-hrv, tesseract-ocr-isl, tesseract-ocr-ita-old, tesseract-ocr-jpn, 
        tesseract-ocr-kan, tesseract-ocr-kor, tesseract-ocr-mal, tesseract-ocr-mkd, 
        tesseract-ocr-mlt, tesseract-ocr-msa, tesseract-ocr-spa-old, tesseract-ocr-sqi, 
        tesseract-ocr-swa, tesseract-ocr-tam, tesseract-ocr-tel, tesseract-ocr-tha, 
        tesseract-ocr-bre, tesseract-ocr-chi-sim-vert, tesseract-ocr-chi-tra-vert, 
        tesseract-ocr-cos, tesseract-ocr-div, tesseract-ocr-fao, tesseract-ocr-fil, 
        tesseract-ocr-fry, tesseract-ocr-gla, tesseract-ocr-hye, tesseract-ocr-jpn-vert, 
        tesseract-ocr-kor-vert, tesseract-ocr-kur-ara, tesseract-ocr-ltz, tesseract-ocr-mon, 
        tesseract-ocr-mri, tesseract-ocr-oci, tesseract-ocr-que, tesseract-ocr-snd, 
        tesseract-ocr-sun, tesseract-ocr-tat, tesseract-ocr-ton, tesseract-ocr-yor, 
        tesseract-ocr-script-arab, tesseract-ocr-script-armn, tesseract-ocr-script-beng, 
        tesseract-ocr-script-cans, tesseract-ocr-script-cher, tesseract-ocr-script-cyrl, 
        tesseract-ocr-script-deva, tesseract-ocr-script-ethi, tesseract-ocr-script-frak, 
        tesseract-ocr-script-geor, tesseract-ocr-script-grek, tesseract-ocr-script-gujr, 
        tesseract-ocr-script-guru, tesseract-ocr-script-hans, tesseract-ocr-script-hans-vert, 
        tesseract-ocr-script-hant, tesseract-ocr-script-hant-vert, tesseract-ocr-script-hang, 
        tesseract-ocr-script-hang-vert, tesseract-ocr-script-hebr, tesseract-ocr-script-jpan, 
        tesseract-ocr-script-jpan-vert, tesseract-ocr-script-knda, tesseract-ocr-script-khmr, 
        tesseract-ocr-script-laoo, tesseract-ocr-script-latn, tesseract-ocr-script-mlym, 
        tesseract-ocr-script-mymr, tesseract-ocr-script-orya, tesseract-ocr-script-sinh, 
        tesseract-ocr-script-syrc, tesseract-ocr-script-taml, tesseract-ocr-script-telu, 
        tesseract-ocr-script-thaa, tesseract-ocr-script-thai, tesseract-ocr-script-tibt, 
        tesseract-ocr-script-viet, tesseract-ocr-grc
Description: Tesseract OCR with all language and script packages
 This is a metapackage for Tesseract OCR and includes all supported
 languages and script.

## tesseract 4.00~git2188-cdc35338

=== debian/changelog ===
tesseract (4.00~git2188-cdc35338-5) unstable; urgency=medium

  * Update README.debian and move to tesseract-ocr package.
  * Sponsor Alexander Pozdnyakov as maintainer.
  * Tweak tesseact --help to reduce bug reports.

 -- Jeff Breidenbach <jab@debian.org>  Mon, 22 Jan 2018 13:27:41 -0800

tesseract (4.00~git2188-cdc35338-4) unstable; urgency=medium

  * Remove dependency on ancient Greek which is not part of Tesseract 4.

 -- Jeff Breidenbach <jab@debian.org>  Thu, 18 Jan 2018 12:07:36 -0800

tesseract (4.00~git2188-cdc35338-3) unstable; urgency=medium

  * Fix small packaging problems such as lintian warnings.
  * Update the package description.

 -- Jeff Breidenbach <jab@debian.org>  Thu, 18 Jan 2018 09:40:48 -0800

tesseract (4.00~git2188-cdc35338-2) unstable; urgency=medium

  * Remerge Alexander's PPA with Debian
  * Patch headers that were causing FTBFS for dependencies.

 -- Jeff Breidenbach <jab@debian.org>  Thu, 21 Dec 2017 22:48:20 -0800

tesseract (4.00~git2188-cdc35338-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/tesseract-ocr/tesseract.git
  * Branch: master
  * Commit: cdc35338c53a1af1fcb95473445f2aabfdb3f6d1
  * Date: 1513247864
  * git changelog:
  *  cdc35338 - Added check if input PSM value is outside of range
    (#1236)

 -- Alexander Pozdnyakov <almipo@mail.ru>  Fri, 15 Dec 2017 22:17:31 +0300

tesseract (4.00~git2187-eba0ae3b-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/tesseract-ocr/tesseract.git
  * Branch: master
  * Commit: eba0ae3b88a46a93e981770caa0b148d65cc4468
  * Date: 1511533887
  * git changelog:
  *  eba0ae3b - Merge pull request #1218 from hsen-dev/master
  *  d7513058 - fixed missing include for std::back_inserter.

 -- Alexander Pozdnyakov <almipo@mail.ru>  Thu, 30 Nov 2017 23:27:52 +0300

tesseract (4.00~git2185-ebbfc3ae-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/tesseract-ocr/tesseract.git
  * Branch: master
  * Commit: ebbfc3ae8df85c351002000a76900e3086375e7b
  * Date: 1510325198
  * git changelog:
  *  ebbfc3ae - Improve robustness of function LoadDataFromFile (#1207)
  *  f3c4b894 - Fix help message for unicharset_extractor (#1206)

 -- Alexander Pozdnyakov <almipo@mail.ru>  Thu, 16 Nov 2017 10:13:25 +0300

tesseract (4.00~git2183-ad5ee184-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/tesseract-ocr/tesseract.git
  * Branch: master
  * Commit: ad5ee18415bf59b9f5d1fd1806cb3aad3f18f381
  * Date: 1508486836
  * git changelog:
  *  ad5ee184 - Make font size estimation work with the lstm engine
    (#1173)
  *  fb359fc9 - Update unicharset_extractor.cpp (#1153)

 -- Alexander Pozdnyakov <almipo@mail.ru>  Fri, 20 Oct 2017 13:13:57 +0300

tesseract (4.00~git2181-1b0379c2-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/tesseract-ocr/tesseract.git
  * Branch: master
  * Commit: 1b0379c25780ded28892fb5c115bb157ab79f3ea
  * Date: 1507035951
  * git changelog:
  *  1b0379c2 - Merge pull request #1163 from cysp/bugfix/leptonica-
    pkgconfig
  *  a538cd12 - Add Leptonica's pkg-config-found library directory to
    the search path
  *  1b4fb3a7 - Update appveyor.yml

 -- Alexander Pozdnyakov <almipo@mail.ru>  Fri, 06 Oct 2017 21:06:08 +0300

tesseract (4.00~git2178-2cc531e6-1) unstable; urgency=medium

  * Compile
  * URL: https://github.com/tesseract-ocr/tesseract.git
  * Branch: master
  * Commit: 2cc531e6bf0288fc8a9ad1c123a252395f00bf56
  * Date: 1505803268
  * git changelog:
  *  2cc531e6 - Merge pull request #1140 from stweil/pagebreak
  *  aa6eb6bd - Remove Tesseract parameter "include_page_breaks" and use
    FF by default
  *  3bb573ae - Merge pull request #1139 from stweil/revert
  *  07f1400e - Revert "change type to UChar32 to fix IsValidCodepoint"
  *  3b62badd - Merge pull request #1134 from
    Shreeshrii/fixvalidcodepoint
  *  a404c9cd - change type to UChar32 to fix IsValidCodepoint

 -- Alexander Pozdnyakov <almipo@mail.ru>  Thu, 21 Sep 2017 14:51:52 +0300

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,24 @@
 Source: tesseract
 Section: graphics
 Priority: optional
-Maintainer: Jeff Breidenbach <jab@debian.org>
+Maintainer: Alexander Pozdnyakov <almipo@mail.ru>
 Build-Depends: debhelper (>= 7.0.50~), libleptonica-dev (>= 1.72~), 
                automake, libtool, libpango1.0-dev, libcairo2-dev, libicu-dev, 
                libpng-dev, libjpeg-dev, libtiff-dev, zlib1g-dev, git, autoconf-archive, asciidoc, 
                xsltproc, docbook-xsl, docbook-xml
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Homepage: https://github.com/tesseract-ocr/
+
+Package: tesseract-ocr
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends},
+ tesseract-ocr-eng (>= 4.00~), tesseract-ocr-osd (>= 4.00~), libtesseract4 (>= 4.00~)
+Replaces: tesseract-ocr-data
+Description: Tesseract command line OCR tool
+ Tesseract is an open source Optical Character Recognition (OCR)
+ Engine. It can be used directly, or (for programmers) using an API to
+ extract printed text from images. It supports a wide variety of
+ languages. This package includes the command line tool.
 
 Package: libtesseract-dev
 Section: libdevel
@@ -16,15 +27,14 @@
 Replaces: tesseract-ocr-dev (<< 3.0.1-1~)
 Breaks: tesseract-ocr-dev (<< 3.0.1-1~)
 Description: Development files for the tesseract command line OCR tool
- The Tesseract OCR engine was one of the top 3 engines in the 1995
- UNLV Accuracy test. Between 1995 and 2006 it had little work done on
- it, but since then it has been improved extensively by Google and is
- probably one of the most accurate open source OCR engines
- available. It can read a wide variety of image formats and convert
- them to text in over 40 languages. This package includes the development
- files, static library, and header files.
+ Tesseract is an open source Optical Character Recognition (OCR)
+ Engine. It can be used directly, or (for programmers) using an API to
+ extract printed text from images. It supports a wide variety of
+ languages. This package includes the development files, static
+ library, and header files.
 
 Package: libtesseract4
+Section: libs
 Breaks: tesseract-ocr (<< 3.01~), ocropus (<< 0.4.0~),
  tesseract-afr (<< 4.00~), tesseract-ara (<< 4.00~), tesseract-aze (<< 4.00~),
  tesseract-bel (<< 4.00~), tesseract-ben (<< 4.00~), tesseract-bul (<< 4.00~),
@@ -66,27 +76,10 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Tesseract OCR library
- The Tesseract OCR engine was one of the top 3 engines in the 1995
- UNLV Accuracy test. Between 1995 and 2006 it had little work done on
- it, but since then it has been improved extensively by Google and is
- probably one of the most accurate open source OCR engines
- available. It can read a wide variety of image formats and convert
- them to text in over 40 languages. This package includes the shared
- library.
-
-Package: tesseract-ocr
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends},
- tesseract-ocr-eng (>= 4.00~), tesseract-ocr-osd (>= 4.00~), libtesseract4 (>= 4.00~)
-Replaces: tesseract-ocr-data
-Description:tesseract command line OCR tool
- The Tesseract OCR engine was one of the top 3 engines in the 1995
- UNLV Accuracy test. Between 1995 and 2006 it had little work done on
- it, but since then it has been improved extensively by Google and is
- probably one of the most accurate open source OCR engines
- available. It can read a wide variety of image formats and convert
- them to text in over 40 languages. This package includes the command
- line tool.
+ Tesseract is an open source Optical Character Recognition (OCR)
+ Engine. It can be used directly, or (for programmers) using an API to
+ extract printed text from images. It supports a wide variety of
+ languages. This package includes the shared library.
 
 Package: tesseract-ocr-all
 Architecture: all
@@ -134,7 +127,7 @@
         tesseract-ocr-script-mymr, tesseract-ocr-script-orya, tesseract-ocr-script-sinh, 
         tesseract-ocr-script-syrc, tesseract-ocr-script-taml, tesseract-ocr-script-telu, 
         tesseract-ocr-script-thaa, tesseract-ocr-script-thai, tesseract-ocr-script-tibt, 
-        tesseract-ocr-script-viet, tesseract-ocr-grc
+        tesseract-ocr-script-viet
 Description: Tesseract OCR with all language and script packages
  This is a metapackage for Tesseract OCR and includes all supported
- languages and script.
+ languages and scripts.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
CFLAGS += -Wall -g -fPIC -DTESSDATA_PREFIX=/usr/share/tesseract-ocr/4.00/

DEBIAN_CODENAME = $(shell echo $$DIST)
ifeq "$(DEBIAN_CODENAME)" ""
	DEBIAN_CODENAME = $(shell dpkg-parsechangelog | awk '/^Distribution: / {print $$2}')
endif
ifneq (,$(filter $(DEBIAN_CODENAME),lucid karmic)) 
	BUILDDEBFLAGS= -- -Zlzma -z9
else
	BUILDDEBFLAGS= -- -Zxz -z9
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

ifeq (,$(NUMJOBS))
	NUMJOBS = 1
endif

%:
	dh $@ --parallel

override_dh_auto_build:
	make -j$(NUMJOBS)
	make -j$(NUMJOBS) training

override_dh_auto_install:
	$(MAKE) DESTDIR=$$(pwd)/debian/tmp prefix=/usr install 
	$(MAKE) DESTDIR=$$(pwd)/debian/tmp prefix=/usr training-install

override_dh_auto_test:

override_dh_auto_clean:
	dh_auto_clean
	dh_clean java/com/Makefile java/com/google/Makefile java/com/google/scrollview/Makefile java/com/google/scrollview/events/Makefile java/com/google/scrollview/ui/Makefile

override_dh_auto_configure:
	sed "s/AM_MAINTAINER_MODE/AM_MAINTAINER_MODE([enable])/g" -i configure.ac
	./autogen.sh
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" CXXFLAGS="$(CFLAGS)" LDFLAGS="-llept -Wl,-z,defs $(LDFLAGS)"


#override_dh_builddeb:
#	dh_builddeb $(BUILDDEBFLAGS)

=== debian/watch ===
version=3
https://github.com/tesseract-ocr/tesseract/releases \
.*[^n]/(?:|v|version-|version|release-|r|REL_|rel-|tesseract(?:-ocr)?(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## tesseract 4.00~git2207

=== CMakeLists.txt ===
#
# tesseract
#

###############################################################################
#
# cmake settings
#
###############################################################################

cmake_minimum_required(VERSION 2.8.11)

# In-source builds are disabled.
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR
        "CMake generation is not possible within the source directory!"
        "\n Remove the CMakeCache.txt file and try again from another folder, e.g.:"
        "\n "
        "\n rm CMakeCache.txt"
        "\n mkdir build"
        "\n cd build"
        "\n cmake .."
    )
endif()

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_SOURCE_DIR}/cmake")

set(EXECUTABLE_OUTPUT_PATH "${CMAKE_BINARY_DIR}/bin")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${EXECUTABLE_OUTPUT_PATH}")

# Use solution folders.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMake Targets")

###############################################################################
#
# project settings
#
###############################################################################

project(tesseract C CXX)

set(VERSION_MAJOR 4)
set(VERSION_MINOR 00)
set(VERSION_PLAIN ${VERSION_MAJOR}.${VERSION_MINOR})

set(MINIMUM_LEPTONICA_VERSION 1.74)

if(NOT EXISTS ${PROJECT_SOURCE_DIR}/.cppan)
    if (NOT Leptonica_DIR AND NOT MSVC)
        find_package(PkgConfig REQUIRED)
        pkg_check_modules(Leptonica REQUIRED lept>=${MINIMUM_LEPTONICA_VERSION})
        link_directories(${Leptonica_LIBRARY_DIRS})
    else()
        find_package(Leptonica ${MINIMUM_LEPTONICA_VERSION} REQUIRED CONFIG)
    endif()
else()
    if (STATIC)
        set(CPPAN_BUILD_SHARED_LIBS 0)
    else()
        set(CPPAN_BUILD_SHARED_LIBS 1)
    endif()
    add_subdirectory(.cppan)
endif()

find_package(OpenCL QUIET)

option(BUILD_TRAINING_TOOLS "Build training tools" ON)

###############################################################################
#
# compiler and linker
#
###############################################################################

set(LIBRARY_TYPE SHARED)
if (STATIC)
    set(LIBRARY_TYPE)
endif()

if (WIN32)
    if (MSVC)
        add_definitions(-D_CRT_SECURE_NO_WARNINGS)

        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /openmp")
    endif()

    set(LIB_Ws2_32 Ws2_32)
endif()

if (CYGWIN)
    add_definitions(-D__CYGWIN__)
endif()

if (UNIX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++11")

    set(LIB_pthread pthread)
endif()

###############################################################################
#
# configure
#
###############################################################################

set(AUTOCONFIG_SRC ${CMAKE_BINARY_DIR}/config_auto.h.in)
set(AUTOCONFIG ${CMAKE_BINARY_DIR}/config_auto.h)

include(Configure)

configure_file(${AUTOCONFIG_SRC} ${AUTOCONFIG} @ONLY)

set(INCLUDE_DIR "${CMAKE_INSTALL_PREFIX}/include" "${CMAKE_INSTALL_PREFIX}/include/tesseract")

configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/templates/TesseractConfig-version.cmake.in
    ${CMAKE_BINARY_DIR}/TesseractConfig-version.cmake @ONLY)
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/templates/TesseractConfig.cmake.in
    ${CMAKE_BINARY_DIR}/TesseractConfig.cmake @ONLY)

###############################################################################
#
# build
#
###############################################################################

include(BuildFunctions)
include(SourceGroups)

add_definitions(-DHAVE_CONFIG_H)
add_definitions(-D_SILENCE_STDEXT_HASH_DEPRECATION_WARNINGS=1)
add_definitions(-DUSE_STD_NAMESPACE=1)
add_definitions(-DWINDLLNAME="libtesseract${VERSION_MAJOR}${VERSION_MINOR}.dll")

include_directories(${Leptonica_INCLUDE_DIRS})

include_directories(${CMAKE_BINARY_DIR})

include_directories(api)
include_directories(arch)
include_directories(ccmain)
include_directories(ccstruct)
include_directories(ccutil)
include_directories(classify)
include_directories(cutil)
include_directories(dict)
include_directories(lstm)
include_directories(opencl)
include_directories(textord)
include_directories(vs2010/port)
include_directories(viewer)
include_directories(wordrec)

########################################
# LIBRARY tesseract
########################################

string(SUBSTRING ${VERSION_MINOR} 0 1 VERSION_MINOR_0)
string(SUBSTRING ${VERSION_MINOR} 1 1 VERSION_MINOR_1)

file(GLOB tesseract_src
    arch/*.cpp
    ccmain/*.cpp
    ccstruct/*.cpp
    ccutil/*.cpp
    classify/*.cpp
    cutil/*.cpp
    dict/*.cpp
    lstm/*.cpp
    opencl/*.cpp
    textord/*.cpp
    viewer/*.cpp
    wordrec/*.cpp
)
file(GLOB tesseract_hdr
    api/*.h
    arch/*.h
    ccmain/*.h
    ccstruct/*.h
    ccutil/*.h
    classify/*.h
    cutil/*.h
    dict/*.h
    lstm/*.h
    opencl/*.h
    textord/*.h
    viewer/*.h
    wordrec/*.h
)
if (WIN32)
    file(GLOB tesseract_win32_src "vs2010/port/*.cpp")
    file(GLOB tesseract_win32_hdr "vs2010/port/*.h")
    set(tesseract_src ${tesseract_src} ${tesseract_win32_src})
    set(tesseract_hdr ${tesseract_hdr} ${tesseract_win32_hdr})
endif()

set(tesseract_src ${tesseract_src}
    api/baseapi.cpp
    api/capi.cpp
    api/renderer.cpp
    api/pdfrenderer.cpp
)

if (WIN32)
    if (MSVC)
        set_source_files_properties(
            ${CMAKE_CURRENT_SOURCE_DIR}/arch/dotproductsse.cpp
            PROPERTIES COMPILE_DEFINITIONS __SSE4_1__)
        set_source_files_properties(
            ${CMAKE_CURRENT_SOURCE_DIR}/arch/intsimdmatrixsse.cpp
            PROPERTIES COMPILE_DEFINITIONS __SSE4_1__)
        set_source_files_properties(
            ${CMAKE_CURRENT_SOURCE_DIR}/arch/dotproductavx.cpp
            PROPERTIES COMPILE_FLAGS "/arch:AVX")
        set_source_files_properties(
            ${CMAKE_CURRENT_SOURCE_DIR}/arch/intsimdmatrixavx2.cpp
            PROPERTIES COMPILE_FLAGS "/arch:AVX2")
    endif()
else()
    set_source_files_properties(
            ${CMAKE_CURRENT_SOURCE_DIR}/arch/dotproductsse.cpp
            PROPERTIES COMPILE_FLAGS "-msse4.1")
    set_source_files_properties(
            ${CMAKE_CURRENT_SOURCE_DIR}/arch/intsimdmatrixsse.cpp
            PROPERTIES COMPILE_FLAGS "-msse4.1")
    set_source_files_properties(
            ${CMAKE_CURRENT_SOURCE_DIR}/arch/dotproductavx.cpp
            PROPERTIES COMPILE_FLAGS "-mavx")
    set_source_files_properties(
            ${CMAKE_CURRENT_SOURCE_DIR}/arch/intsimdmatrixavx2.cpp
            PROPERTIES COMPILE_FLAGS "-mavx2")
endif()

add_library                     (libtesseract ${LIBRARY_TYPE} ${tesseract_src} ${tesseract_hdr})
if (NOT STATIC)
target_compile_definitions      (libtesseract
    PRIVATE -DTESS_EXPORTS
    INTERFACE -DTESS_IMPORTS
)
set_target_properties           (libtesseract PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS True)
endif()
target_link_libraries           (libtesseract ${LIB_Ws2_32} ${LIB_pthread})
set_target_properties           (libtesseract PROPERTIES VERSION ${VERSION_MAJOR}.${VERSION_MINOR_0}.${VERSION_MINOR_1})
set_target_properties           (libtesseract PROPERTIES SOVERSION ${VERSION_MAJOR}.${VERSION_MINOR_0}.${VERSION_MINOR_1})
if (WIN32)
set_target_properties           (libtesseract PROPERTIES OUTPUT_NAME tesseract${VERSION_MAJOR}${VERSION_MINOR})
set_target_properties           (libtesseract PROPERTIES DEBUG_OUTPUT_NAME tesseract${VERSION_MAJOR}${VERSION_MINOR}d)
else()
set_target_properties           (libtesseract PROPERTIES OUTPUT_NAME tesseract)
endif()

if (NOT CPPAN_BUILD)
    target_link_libraries       (libtesseract ${Leptonica_LIBRARIES})
    export(TARGETS libtesseract FILE ${CMAKE_BINARY_DIR}/TesseractTargets.cmake)
else()
    target_link_libraries       (libtesseract pvt.cppan.demo.danbloomberg.leptonica)
    file(WRITE ${CMAKE_BINARY_DIR}/TesseractTargets.cmake "include(${CMAKE_BINARY_DIR}/cppan.cmake)\n")
    export(TARGETS libtesseract APPEND FILE ${CMAKE_BINARY_DIR}/TesseractTargets.cmake)
endif()

########################################
# EXECUTABLE tesseractmain
########################################

set(tesseractmain_src
    api/tesseractmain.cpp
    vs2010/tesseract/resource.h
    vs2010/tesseract/tesseract.rc
)
add_executable                  (tesseract ${tesseractmain_src})
target_link_libraries           (tesseract libtesseract)

########################################

if (EXISTS ${PROJECT_SOURCE_DIR}/googletest/CMakeLists.txt)
    add_subdirectory(googletest)
    add_executable(tesseract_tests tests/tesseracttests.cpp)
    target_link_libraries(tesseract_tests gtest_main)
endif()

if (BUILD_TRAINING_TOOLS)
add_subdirectory(training)
endif()

get_target_property(tesseract_NAME libtesseract NAME)
get_target_property(tesseract_VERSION libtesseract VERSION)
get_target_property(tesseract_OUTPUT_NAME libtesseract OUTPUT_NAME)
configure_file(tesseract.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/tesseract.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tesseract.pc DESTINATION lib/pkgconfig)
install(TARGETS tesseract RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
install(TARGETS libtesseract EXPORT TesseractTargets RUNTIME DESTINATION bin LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
install(EXPORT TesseractTargets DESTINATION cmake)
install(FILES
    ${CMAKE_BINARY_DIR}/TesseractConfig.cmake
    ${CMAKE_BINARY_DIR}/TesseractConfig-version.cmake
    DESTINATION cmake)

install(FILES
    # from api/makefile.am
    api/apitypes.h
    api/baseapi.h
    api/capi.h
    api/renderer.h

    #from arch/makefile.am
    arch/dotproductavx.h
    arch/dotproductsse.h
    arch/intsimdmatrix.h
    arch/intsimdmatrixavx2.h
    arch/intsimdmatrixsse.h
    arch/simddetect.h

    #from ccmain/makefile.am
    ccmain/thresholder.h
    ccmain/ltrresultiterator.h
    ccmain/pageiterator.h
    ccmain/resultiterator.h
    ccmain/osdetect.h

    #from ccstruct/makefile.am
    ccstruct/publictypes.h

    #from ccutil/makefile.am
    ccutil/basedir.h
    ccutil/errcode.h
    ccutil/fileerr.h
    ccutil/genericvector.h
    ccutil/helpers.h
    ccutil/host.h
    ccutil/memry.h
    ccutil/ndminx.h
    ccutil/params.h
    ccutil/ocrclass.h
    ccutil/platform.h
    ccutil/serialis.h
    ccutil/strngs.h
    ccutil/tesscallback.h
    ccutil/unichar.h
    ccutil/unicharcompress.h
    ccutil/unicharmap.h
    ccutil/unicharset.h
    ccutil/version.h

    #from lstm/makefile.am
    lstm/convolve.h
    lstm/ctc.h
    lstm/fullyconnected.h
    lstm/functions.h
    lstm/input.h
    lstm/lstm.h
    lstm/lstmrecognizer.h
    lstm/lstmtrainer.h
    lstm/maxpool.h
    lstm/networkbuilder.h
    lstm/network.h
    lstm/networkio.h
    lstm/networkscratch.h
    lstm/parallel.h
    lstm/plumbing.h
    lstm/recodebeam.h
    lstm/reconfig.h
    lstm/reversed.h
    lstm/series.h
    lstm/static_shape.h
    lstm/stridemap.h
    lstm/tfnetwork.h
    lstm/weightmatrix.h

    #${CMAKE_BINARY_DIR}/src/endianness.h
    DESTINATION include/tesseract)


###############################################################################

=== training/CMakeLists.txt ===
#
# tesseract
#

if (NOT CPPAN_BUILD AND NOT (WIN32 OR CYGWIN))
    return()
endif()

if (CPPAN_BUILD)
    set(ICU_FOUND 1)
endif()

# experimental
if (MSVC AND NOT CPPAN_BUILD AND NOT USE_SYSTEM_ICU)
    include(CheckTypeSize)
    check_type_size("void *" SIZEOF_VOID_P)

    if (SIZEOF_VOID_P EQUAL 8)
        set(X64 1)
        set(ARCH_DIR_NAME 64)
    elseif (SIZEOF_VOID_P EQUAL 4)
        set(X86 1)
        set(ARCH_DIR_NAME 32)
    else()
        message(FATAL_ERROR "Cannot determine target architecture")
    endif()

    set(icu_dir "${CMAKE_CURRENT_BINARY_DIR}/icu")
    set(icu_archive "${icu_dir}/icu${ARCH_DIR_NAME}.zip")

    if (X86)
        set(icu_hash 45167a240b60e36b59a87eda23490ce4)
    else()
        set(icu_hash 480c72491576c048de1218c3c5519399)
    endif()

    message(STATUS "Downloading latest ICU binaries")

    file(DOWNLOAD
        "http://download.icu-project.org/files/icu4c/56.1/icu4c-56_1-Win${ARCH_DIR_NAME}-msvc10.zip"
        "${icu_archive}"
        SHOW_PROGRESS
        INACTIVITY_TIMEOUT 60 # seconds
        EXPECTED_HASH MD5=${icu_hash}
    )
    execute_process(COMMAND ${CMAKE_COMMAND} -E tar xz "${icu_archive}"
        WORKING_DIRECTORY "${icu_dir}"
        RESULT_VARIABLE __result
    )
    if(NOT __result EQUAL 0)
        message(FATAL_ERROR "error ${__result}")
    endif()

    set(ICU_ROOT ${icu_dir}/icu)
endif()
# experimental

if (NOT CPPAN_BUILD)
    find_package(ICU COMPONENTS uc i18n)
endif()

########################################
# LIBRARY tessopt
########################################

add_library                 (tessopt tessopt.cpp tessopt.h)
project_group               (tessopt "Training Tools")


########################################
# LIBRARY common_training
########################################

set(common_training_src
    commandlineflags.cpp
    commandlineflags.h
    commontraining.cpp
    commontraining.h
)
add_library                 (common_training ${common_training_src})
target_link_libraries       (common_training libtesseract tessopt)
project_group               (common_training "Training Tools")


########################################
# EXECUTABLE ambiguous_words
########################################

add_executable              (ambiguous_words ambiguous_words.cpp)
target_link_libraries       (ambiguous_words libtesseract)
project_group               (ambiguous_words "Training Tools")


########################################
# EXECUTABLE classifier_tester
########################################

add_executable              (classifier_tester classifier_tester.cpp)
target_link_libraries       (classifier_tester common_training)
project_group               (classifier_tester "Training Tools")


########################################
# EXECUTABLE combine_tessdata
########################################

add_executable              (combine_tessdata combine_tessdata.cpp)
target_link_libraries       (combine_tessdata libtesseract)
project_group               (combine_tessdata "Training Tools")


########################################
# EXECUTABLE cntraining
########################################

add_executable              (cntraining cntraining.cpp)
target_link_libraries       (cntraining common_training)
project_group               (cntraining "Training Tools")


########################################
# EXECUTABLE dawg2wordlist
########################################

add_executable              (dawg2wordlist dawg2wordlist.cpp)
target_link_libraries       (dawg2wordlist libtesseract)
project_group               (dawg2wordlist "Training Tools")


########################################
# EXECUTABLE mftraining
########################################

add_executable              (mftraining mftraining.cpp mergenf.cpp mergenf.h)
target_link_libraries       (mftraining common_training)
project_group               (mftraining "Training Tools")


########################################
# EXECUTABLE shapeclustering
########################################

add_executable              (shapeclustering shapeclustering.cpp)
target_link_libraries       (shapeclustering common_training)
project_group               (shapeclustering "Training Tools")


########################################
# EXECUTABLE wordlist2dawg
########################################

add_executable              (wordlist2dawg wordlist2dawg.cpp)
target_link_libraries       (wordlist2dawg libtesseract)
project_group               (wordlist2dawg "Training Tools")


if (ICU_FOUND)

if (NOT CPPAN_BUILD)
include_directories(${ICU_INCLUDE_DIRS})
endif()

########################################
# LIBRARY unicharset_training
########################################

set(unicharset_training_src
    fileio.cpp
    fileio.h
    icuerrorcode.h
    lang_model_helpers.cpp
    lang_model_helpers.h
    lstmtester.cpp
    lstmtester.h
    normstrngs.cpp
    normstrngs.h
    unicharset_training_utils.cpp
    unicharset_training_utils.h

    validate_grapheme.h validate_indic.h validate_khmer.h
    validate_myanmar.h validator.h
    validate_grapheme.cpp validate_indic.cpp validate_khmer.cpp
    validate_myanmar.cpp validator.cpp

)
add_library                 (unicharset_training ${unicharset_training_src})
if (NOT CPPAN_BUILD)
target_link_libraries       (unicharset_training common_training ${ICU_LIBRARIES})
else()
target_link_libraries       (unicharset_training common_training pvt.cppan.demo.unicode.icu.i18n)
endif()
project_group               (unicharset_training "Training Tools")


########################################
# EXECUTABLE combine_lang_model
########################################

add_executable              (combine_lang_model combine_lang_model.cpp)
target_link_libraries       (combine_lang_model unicharset_training)
project_group               (combine_lang_model "Training Tools")


########################################
# EXECUTABLE lstmeval
########################################

add_executable              (lstmeval lstmeval.cpp)
target_link_libraries       (lstmeval unicharset_training)
project_group               (lstmeval "Training Tools")


########################################
# EXECUTABLE lstmtraining
########################################

add_executable              (lstmtraining lstmtraining.cpp)
target_link_libraries       (lstmtraining unicharset_training)
project_group               (lstmtraining "Training Tools")


########################################
# EXECUTABLE set_unicharset_properties
########################################

add_executable              (set_unicharset_properties set_unicharset_properties.cpp)
target_link_libraries       (set_unicharset_properties unicharset_training)
project_group               (set_unicharset_properties "Training Tools")


########################################
# EXECUTABLE unicharset_extractor
########################################

add_executable              (unicharset_extractor unicharset_extractor.cpp)
target_link_libraries       (unicharset_extractor libtesseract tessopt unicharset_training)
project_group               (unicharset_extractor "Training Tools")


########################################
# EXECUTABLE text2image
########################################

if (NOT CPPAN_BUILD)
find_package(PkgConfig)
endif()

if (PKG_CONFIG_FOUND OR CPPAN_BUILD)

if (PKG_CONFIG_FOUND)
pkg_check_modules(Pango REQUIRED pango)
pkg_check_modules(Cairo REQUIRED cairo)
pkg_check_modules(PangoFt2 REQUIRED pangoft2)
pkg_check_modules(PangoCairo REQUIRED pangocairo)
pkg_check_modules(FontConfig REQUIRED fontconfig)
endif()

set(text2image_src
    text2image.cpp
    boxchar.cpp
    boxchar.h
    degradeimage.cpp
    degradeimage.h
    ligature_table.cpp
    ligature_table.h
    normstrngs.cpp
    normstrngs.h
    pango_font_info.cpp
    pango_font_info.h
    stringrenderer.cpp
    stringrenderer.h
    tlog.cpp
    tlog.h
    util.h
    icuerrorcode.h
)

add_executable              (text2image ${text2image_src})
target_link_libraries       (text2image unicharset_training)
if (PKG_CONFIG_FOUND)
target_include_directories  (text2image BEFORE PRIVATE ${Cairo_INCLUDE_DIRS} ${Pango_INCLUDE_DIRS})
target_compile_definitions  (text2image PRIVATE -DPANGO_ENABLE_ENGINE)
target_link_libraries       (text2image
    ${Pango_LIBRARIES}
    ${Cairo_LIBRARIES}
    ${PangoCairo_LIBRARIES}
    ${PangoFt2_LIBRARIES}
    ${FontConfig_LIBRARIES}
)
endif()
if (CPPAN_BUILD)
target_link_libraries       (text2image pvt.cppan.demo.gnome.pango.pangocairo)
endif()
project_group               (text2image "Training Tools")

endif()
endif(ICU_FOUND)

###############################################################################
